library ieee;
use ieee.std_logic_1164.all;

entity testcount is
end testcount;

architecture test of testcount is

component it_count
  port (cnt_in  : in std_logic_vector (3 downto 0);
        count   : in std_logic;
        cnt_out : out std_logic_vector (3 downto 0)
       );
end component;

component pcount_decoder 
  port (din  : in std_logic_vector (4 downto 0);
        dout : out std_logic_vector (3 downto 0)
       );
end component;

signal cntin : std_logic_vector (3 downto 0) := "1111";
signal cntout: std_logic_vector (3 downto 0);
signal count : std_logic := '1';
signal hbit : std_logic := '0';
signal din : std_logic_vector (4 downto 0);
signal dout : std_logic_vector (3 downto 0);

begin

  u0: it_count port map
   (cnt_in=>cntin, count=>count, cnt_out=>cntout);

  din <= hbit & cntout;

  u1: pcount_decoder port map
   ( din=>din, dout=>dout);

  verify : process

    variable i : integer := 0;

  begin
    while (i<16) loop
      wait for 100 ns;
      i := i + 1;
      cntin <= cntout;
    end loop;
    
    hbit <= '1';
    while (i<32) loop
      wait for 100 ns;
      i := i + 1;
      cntin <= cntout;
    end loop;
    
    assert false
      report "Simulation is done."
      severity note;
    wait;

  end process;

end test;
 
